## csound-plugins 1.0.2~dfsg1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)
project(Csound-plugins)
if (${CMAKE_CXX_COMPILER_ID} STREQUAL "Clang")
    set(CMAKE_COMPILER_IS_CLANG 1)
endif()
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g")

# C++11 needed
if(NOT MSVC)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
endif()

set(APIVERSION "6.0")

set(CMAKE_MACOSX_RPATH 1)
set(CMAKE_VERBOSE_MAKEFILE ON)
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH}
"${CMAKE_SOURCE_DIR}/cmake/Modules/")

find_package(CSOUND)
if(NOT CSOUND_INCLUDE_DIRS)
      message(FATAL_ERROR "Csound header files are required")
endif()

include(TestBigEndian)
include(CheckFunctionExists)
include(CheckCCompilerFlag)
include(CheckCXXCompilerFlag)

### COMPILER OPTIMIZATION FLAGS
option(USE_COMPILER_OPTIMIZATIONS "Use the default Csound compiler optimization flags" ON)
if(USE_COMPILER_OPTIMIZATIONS)
    include(${CMAKE_SOURCE_DIR}/cmake/CompilerOptimizations.cmake)
endif()

##/Library/Frameworks/CsoundLib64.framework/Versions/Current/Resources/Opcodes64

if(APPLE)
     message(STATUS "Building on OSX")
    set(OSX_VERSION " ")
endif()

## USER OPTIONS ##
# Optional targets, they should all default to ON (check_deps will disable them if not possible to build)
option(USE_DOUBLE "Set to use double-precision floating point for audio samples." ON)
option(USE_LRINT "Use lrint/lrintf for converting floating point values to integers." ON)
option(BUILD_RELEASE "Build for release" ON)
option(USE_GIT_COMMIT "Show the git commit in version information" ON)
option(REQUIRE_PTHREADS "For non-Windows systems, set whether Csound will use threads or not" ON)

# in Release configuration, set NDEBUG
if(${CMAKE_BUILD_TYPE} MATCHES "Release")
message("-----> Release mode")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DNDEBUG")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DNDEBUG")
elseif(${CMAKE_BUILD_TYPE} MATCHES "Debug")
message("-----> Debug mode")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DBETA")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DBETA")
endif()

# set -Werror if in Debug configuration
if(NOT MSVC AND NOT WASM)
    set(CMAKE_CXX_FLAGS_RELEASE "-O3 ")
    set(CMAKE_C_FLAGS_RELEASE "-O3 ")
    if(${CMAKE_BUILD_TYPE} MATCHES "Debug")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  -Wall -Werror -Wno-missing-field-initializers")
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Werror -Wno-missing-field-initializers")
    endif()
endif()

if(NOT MSVC AND REQUIRE_PTHREADS)
  # Use ladder of if's to support older CMake versions (i.e., travis)
  find_library(PTHREAD_LIBRARY winpthread-1)
  if(NOT PTHREAD_LIBRARY)
    find_library(PTHREAD_LIBRARY pthread)
  endif()
  if(NOT PTHREAD_LIBRARY)
    find_library(PTHREAD_LIBRARY pthreadGC2)
  endif()

  if(NOT (PTHREAD_LIBRARY OR HAIKU))
      # pthreads are built in to Haiku
      message(STATUS "Csound requires the pthread library")
  endif()

  #FIXME this variable is for required include directories, possible bug
  list(APPEND CMAKE_REQUIRED_INCLUDES pthread.h)
  if (NOT HAIKU)
    set(CMAKE_REQUIRED_LIBRARIES pthread)
  endif()
endif()

if(CMAKE_SYSTEM_NAME MATCHES "Linux")
    set(LINUX YES)
else()
    set(LINUX NO)
endif()

set(BUILD_DIR ${CMAKE_CURRENT_BINARY_DIR})
check_c_compiler_flag(-fvisibility=hidden HAS_VISIBILITY_HIDDEN)
check_cxx_compiler_flag(-fvisibility=hidden HAS_CXX_VISIBILITY_HIDDEN)
if (HAS_VISIBILITY_HIDDEN)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fvisibility=hidden")
endif()
if (HAS_CXX_VISIBILITY_HIDDEN)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility=hidden")
endif()

check_c_compiler_flag(-std=gnu99 HAS_GNU99)
if (HAS_GNU99)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu99")
endif()
if (HAS_CXX_VISIBILITY_HIDDEN)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility=hidden")
endif()

if(LINUX)
option(USE_LIB64 "Set to on to set installation directory for
libraries to lib64" OFF)
if(USE_LIB64)
    set(LIBRARY_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/lib64")
    add_definitions("-DLIB64")
else()
    set(LIBRARY_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/lib")
endif()
message(STATUS "LIBRARY INSTALL DIR: ${LIBRARY_INSTALL_DIR}")
endif()

# plugin install directories (CS_USER_PLUGIN on MacOs/Windows)
if(USE_DOUBLE)
    message(STATUS "Building with 64-bit floats")
    if(APPLE)
     set(PLUGIN_INSTALL_DIR
       "$ENV{HOME}/Library/csound/${APIVERSION}/plugins64" CACHE PATH "Plugin install path")
    elseif(LINUX)
      set(PLUGIN_INSTALL_DIR
      "${LIBRARY_INSTALL_DIR}/csound/plugins64-${APIVERSION}")
     elseif(WINDOWS)
      set(PLUGIN_INSTALL_DIR "${env.LOCALAPPDATA}/csound/${APIVERSION}/plugins64")
    endif()
else()
    message(STATUS "Building with 32-bit floats")
    if(APPLE)
        set(PLUGIN_INSTALL_DIR
    "$ENV{HOME}/Library/csound/${APIVERSION}/plugins" CACHE PATH "Plugin install path")
    elseif(LINUX)
      set(PLUGIN_INSTALL_DIR
      "${LIBRARY_INSTALL_DIR}/csound/plugins-${APIVERSION}")
     elseif(WINDOWS)
      set(PLUGIN_INSTALL_DIR "${env.LOCALAPPDATA}/csound/${APIVERSION}/plugins")
      endif()
endif()

message("-- Csound headers: ${CSOUND_INCLUDE_DIR}")
if(APPLE)
   message("-- Csound framework: ${CSOUND_FRAMEWORK}")
endif()
message("-- Plugins to be installed at: ${PLUGIN_INSTALL_DIR}")

# Checks if dependencies for an enabled target are fulfilled.
# If FAIL_MISSING is true and the dependencies are not fulfilled,
# it will abort the cmake run.
# If FAIL_MISSING is false, it will set the option to OFF.
# If the target is not enabled, it will do nothing.
# example: check_deps(BUILD_NEW_PARSER FLEX_EXECUTABLE BISON_EXECUTABLE)
function(check_deps option)
    if(${option})
        set(i 1)
        while( ${i} LESS ${ARGC} )
            set(dep ${ARGV${i}})
            if(NOT ${dep})
                if(FAIL_MISSING)
                    message(FATAL_ERROR
                        "${option} is enabled, but ${dep}=\"${${dep}}\"")
                else()
                    message(STATUS "${dep}=\"${${dep}}\", so disabling ${option}")
                    set(${option} OFF PARENT_SCOPE)
                    # Set it in the local scope too
                    set(${option} OFF)
                endif()
            endif()
            math(EXPR i "${i}+1")
        endwhile()
    endif()
    if(${option})
        message(STATUS "${option} is enabled.")
    else()
        message(STATUS "${option} is disabled.")
    endif()
endfunction(check_deps)

# Utility function to make plugins. All plugin targets should use this as it
# sets up output directory set in top-level CmakeLists.txt
# and adds the appropriate install target
#
# libname - name of library to produce
# srcs - list of src files (must be quoted if a list)
# extralibs (OPTIONAL) - extra libraries to link the plugin to
#
# NB - this was moved here as it needs some VARS defined above
# for setting up the framework
function(make_plugin libname srcs)
    if(APPLE)
        add_library(${libname} SHARED ${srcs})
    else()
        add_library(${libname} MODULE ${srcs})
    endif()

    set(i 2)
    while( ${i} LESS ${ARGC} )
        target_link_libraries(${libname} ${ARGV${i}})
        math(EXPR i "${i}+1")
    endwhile()

   # set_target_properties(${libname} PROPERTIES
    #    RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
     #   LIBRARY_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
      #  ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})

    install(TARGETS ${libname}
        LIBRARY DESTINATION "${PLUGIN_INSTALL_DIR}" 
        ARCHIVE DESTINATION "${PLUGIN_INSTALL_DIR}" )
endfunction(make_plugin)

#checking pthread functions
if(REQUIRE_PTHREADS AND (PTHREAD_LIBRARY OR HAIKU))

  #list(APPEND libcsound_CFLAGS -DHAVE_PTHREAD)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DHAVE_PTHREAD")

  check_function_exists(pthread_spin_lock PTHREAD_SPIN_LOCK_EXISTS)
  check_function_exists(pthread_barrier_init PTHREAD_BARRIER_INIT_EXISTS)

  if(PTHREAD_SPIN_LOCK_EXISTS)
     list(APPEND libcsound_CFLAGS -DHAVE_PTHREAD_SPIN_LOCK)
  endif()

  if(PTHREAD_BARRIER_INIT_EXISTS)
     list(APPEND libcsound_CFLAGS -DHAVE_PTHREAD_BARRIER_INIT)
  endif()
endif()

# Linux does not have a separate libintl, it is part of libc
set(LIBINTL_AVAIL (LIBINTL_LIBRARY OR LINUX))

if(LINUX)
    message(STATUS "Building on Linux.")
    add_definitions(-DLINUX -DPIPES -DNO_FLTK_THREADS -D_GNU_SOURCE -DHAVE_SOCKETS)
    list(APPEND libcsound_LIBS ${MATH_LIBRARY} dl)

    find_library(LIBRT_LIBRARY rt)

    if(LIBRT_LIBRARY)
      list(APPEND libcsound_LIBS ${LIBRT_LIBRARY})
      message(STATUS "  ADDING LIBRT LIBRARY: ${LIBRT_LIBRARY}.")
    endif()

    find_library(LIBEXECINFO_LIBRARY execinfo)

    if(LIBEXECINFO_LIBRARY)
       list(APPEND libcsound_LIBS ${LIBEXECINFO_LIBRARY})
       message(STATUS "  ADDING LIBEXECINFO LIBRARY: ${LIBEXECINFO_LIBRARY}.")
    endif()
endif()

if(APPLE AND NOT IOS)
    add_definitions(-DMACOSX -DPIPES -DNO_FLTK_THREADS -DHAVE_SOCKETS)
    find_library(ACCELERATE_LIBRARY Accelerate)
    find_path(VECLIB_PATH "Accelerate/Accelerate.h")
    include_directories(${VECLIB_PATH})
    list(APPEND libcsound_LIBS ${MATH_LIBRARY} dl ${ACCELERATE_LIBRARY})
endif()

if(WIN32)
    add_definitions(-DWIN32)
endif()

add_subdirectory(chua)
add_subdirectory(faustcsound)
add_subdirectory(image)
add_subdirectory(py)
add_subdirectory(widgets)
add_subdirectory(AbletonLinkOpcodes)
add_subdirectory(stk)
add_subdirectory(CUDA)
add_subdirectory(opencl)
add_subdirectory(websockets)
add_subdirectory(hdf5)
add_subdirectory(linear_algebra)
add_subdirectory(mp3)
add_subdirectory(wiimote)
add_subdirectory(p5glove)
add_subdirectory(jackops)
add_subdirectory(fluidOpcodes)

=== AbletonLinkOpcodes/CMakeLists.txt ===
# Build Ableton Link Opcodes
option(BUILD_ABLETON_LINK_OPCODES "Build the Ableton link opcodes" ON)
check_deps(BUILD_ABLETON_LINK_OPCODES ABLETON_LINK_HOME)
if(BUILD_ABLETON_LINK_OPCODES)
    message(STATUS "Ableton Link home: ${ABLETON_LINK_HOME}")
    if(APPLE)
      make_plugin(ableton_link_opcodes ableton_link_opcodes.cpp)
      set_target_properties(ableton_link_opcodes PROPERTIES COMPILE_FLAGS "-std=c++11 -stdlib=libc++ -Wno-multichar -DLINK_PLATFORM_MACOSX=1"
        LINK_FLAGS "-std=c++11 -stdlib=libc++")
    elseif(LINUX)
        include(CheckCXXCompilerFlag)
        CHECK_CXX_COMPILER_FLAG("-std=gnu++11" COMPILER_SUPPORTS_CXX11)
        if(COMPILER_SUPPORTS_CXX11)
            make_plugin(ableton_link_opcodes ableton_link_opcodes.cpp)
            set_target_properties(ableton_link_opcodes PROPERTIES COMPILE_FLAGS "-std=gnu++11 -Wno-multichar -DLINK_PLATFORM_LINUX=1")
        else()
            message(STATUS "Not building ableton_link_opcodes as no C++11 support found.")
        endif()
    else()
        make_plugin(ableton_link_opcodes ableton_link_opcodes.cpp)
        if(WIN32)
            if(MSVC)
                include_directories($ENV{INCLUDE})
                include(${ABLETON_LINK_HOME}\\AbletonLinkConfig.cmake)
                target_link_libraries(ableton_link_opcodes Ableton::Link)
            else()
                set_target_properties(ableton_link_opcodes PROPERTIES COMPILE_FLAGS "-std=gnu++11 -Wno-multichar -DLINK_PLATFORM_WINDOWS=1"
                    LINK_FLAGS "-std=gnu++11")
                target_link_libraries(ableton_link_opcodes wsock32 ws2_32 iphlpapi)
            endif()
        endif()
    endif()
    target_include_directories(ableton_link_opcodes PRIVATE ${CSOUND_INCLUDE_DIRS})
    target_include_directories(ableton_link_opcodes PRIVATE ${ABLETON_LINK_HOME}/include)
    target_include_directories(ableton_link_opcodes PRIVATE ${ABLETON_LINK_HOME}/modules/asio-standalone/asio/include)
    install(TARGETS ableton_link_opcodes
        LIBRARY DESTINATION ${PLUGIN_INSTALL_DIR}
        ARCHIVE DESTINATION ${LIBRARY_INSTALL_DIR})
endif()

=== CUDA/CMakeLists.txt ===
option(BUILD_CUDA_OPCODES "Build the CUDA GPU opcodes" OFF)

if(BUILD_CUDA_OPCODES)
 FIND_PACKAGE(CUDA REQUIRED)
 check_deps(BUILD_CUDA_OPCODES CUDA_FOUND)
 if(BUILD_CUDA_OPCODES)
 message(STATUS "Building the CUDA opcodes")

 function(make_cuda_plugin libname srcs)

 SET(LIB_TYPE_DYNAMIC) #set the lib type
 CUDA_ADD_LIBRARY(${libname} ${LIB_TYPE} ${srcs})

    set(i 2)
    while( ${i} LESS ${ARGC} )
        target_link_libraries(${libname} ${ARGV${i}})
        math(EXPR i "${i}+1")
    endwhile()

    set_target_properties(${libname} PROPERTIES
        RUNTIME_OUTPUT_DIRECTORY ${BUILD_PLUGINS_DIR}
        LIBRARY_OUTPUT_DIRECTORY ${BUILD_PLUGINS_DIR}
        ARCHIVE_OUTPUT_DIRECTORY ${BUILD_PLUGINS_DIR})

    install(TARGETS ${libname}
	LIBRARY DESTINATION "${PLUGIN_INSTALL_DIR}" )

endfunction(make_cuda_plugin)

 #find_library(CUFFT cufft HINTS "/Developer/NVIDIA/CUDA-6.0/lib")
 include_directories(${CMAKE_HOME_DIRECTORY}/include)
 include_directories(/usr/local/include)

 if(APPLE)
 if(CMAKE_OSX_DEPLOYMENT_TARGET MATCHES 10.6)
 SET(CUDA_NVCC_FLAGS  "-arch=sm_11 -use_fast_math" CACHE STRING "nvcc flags" FORCE)
  make_cuda_plugin(cudaop1 adsyn11.cu)
  make_cuda_plugin(cudaop2 pvsopsf.cu)
  make_cuda_plugin(cudaop3 slidingm.cu)
  make_cuda_plugin(cudaop4 convf.cu)
   make_cuda_plugin(cudaop5 pconv11.cu)
   CUDA_ADD_CUFFT_TO_TARGET(cudaop2)
      CUDA_ADD_CUFFT_TO_TARGET(cudaop5)
 # target_link_libraries(cudaop2 ${CUFFT})
 #target_link_libraries(cudaop5 ${CUFFT})
 else()
SET(CUDA_NVCC_FLAGS  "-ccbin /usr/bin/clang -arch=sm_30
 -Xcompiler  -stdlib=libstdc++ -use_fast_math" CACHE STRING "nvcc flags" FORCE)
  make_cuda_plugin(cudaop1 adsyn.cu)
  make_cuda_plugin(cudaop2 pvsops.cu)
  make_cuda_plugin(cudaop3 slidingm.cu)
  make_cuda_plugin(cudaop4 conv.cu)
   make_cuda_plugin(cudaop5 pconv.cu)
   CUDA_ADD_CUFFT_TO_TARGET(cudaop2)
   CUDA_ADD_CUFFT_TO_TARGET(cudaop5)
   #target_link_libraries(cudaop5 ${CUFFT})
  #target_link_libraries(cudaop2 ${CUFFT})
 endif()
 else()
   if(CUDA_VERSION VERSION_LESS 9.0)
  SET(CUDA_NVCC_FLAGS  "-arch=sm_20 -use_fast_math" CACHE STRING "nvcc flags" FORCE)
   else()
  SET(CUDA_NVCC_FLAGS  "-arch=sm_30 -use_fast_math" CACHE STRING "nvcc flags" FORCE)
   endif()
  make_cuda_plugin(cudaop1 adsyn.cu)
  make_cuda_plugin(cudaop2 pvsops.cu)
  make_cuda_plugin(cudaop3 slidingm.cu)
  make_cuda_plugin(cudaop4 conv.cu)
  make_cuda_plugin(cudaop5 pconv.cu)
  CUDA_ADD_CUFFT_TO_TARGET(cudaop2)
   CUDA_ADD_CUFFT_TO_TARGET(cudaop5)
   #target_link_libraries(cudaop5 ${CUFFT})
  #target_link_libraries(cudaop2 ${CUFFT})
 endif()

 SET (CUDA_VERBOSE_BUILD ON CACHE BOOL "nvcc verbose" FORCE)

 else()
 message(STATUS "Not Building the CUDA opcodes")
 endif()
else()
message(STATUS "Not building the CUDA opcodes")
endif()

=== chua/CMakeLists.txt ===
# Build chuap opcodes
option(BUILD_CHUA_OPCODES "Build the chua opcodes" ON)

if(${BUILD_CHUA_OPCODES})
    find_package(EIGEN3)
    check_deps(BUILD_CHUA_OPCODES EIGEN3_FOUND)
    if(BUILD_CHUA_OPCODES)
	make_plugin(chua ChuaOscillator.cpp)
        target_include_directories(chua PRIVATE ${EIGEN3_INCLUDE_DIR})
	target_include_directories(chua PRIVATE ${CSOUND_INCLUDE_DIRS})
	target_link_libraries(chua PRIVATE ${EIGEN_LIBRARIES})
	if(APPLE)
	   set_target_properties(chua PROPERTIES COMPILE_FLAGS "-Wno-unused-local-typedef")
	endif()
    endif()
endif()

=== faustcsound/CMakeLists.txt ===
# Build faustcsound opcodes
option(BUILD_FAUST_OPCODES "Build the Faust opcodes" ON)
find_package(FAUST)
check_deps(BUILD_FAUST_OPCODES FAUST_FOUND)
if(BUILD_FAUST_OPCODES)
    make_plugin(faustcsound faustgen.cpp)
    if(APPLE)
     set_target_properties(faustcsound PROPERTIES
     INSTALL_RPATH_USE_LINK_PATH TRUE)
    endif() 
    target_include_directories(faustcsound PRIVATE ${CSOUND_INCLUDE_DIRS})
    target_link_libraries(faustcsound ${PTHREAD_LIBRARY})
    target_compile_definitions(faustcsound PRIVATE "-DFAUSTFLOAT=MYFLT")

    if(PTHREAD_LIBRARY)
        target_compile_definitions(faustcsound PRIVATE "-DHAVE_PTHREAD")
    endif()

    if(APPLE)
        if(${OSX_VERSION} STREQUAL "10.6")
            target_link_libraries(faustcsound ${FAUST_LIBRARIES})
        else()
            target_compile_options(faustcsound PRIVATE "-stdlib=libc++")
            target_link_libraries(faustcsound ${FAUST_LIBRARIES} -stdlib=libc++)
        endif()
    else()
        target_link_libraries(faustcsound ${FAUST_LIBRARIES})
    endif()
    target_include_directories(faustcsound PRIVATE ${FAUST_INCLUDE_DIR})
    message("-- FAUST INCLUDE DIR: ${FAUST_INCLUDE_DIR}")
endif()

=== fluidOpcodes/CMakeLists.txt ===
option(BUILD_FLUID_OPCODES "Build the fluidsynth opcodes" ON)

find_package(FLUIDSYNTH)
if(BUILD_FLUID_OPCODES AND FLUIDSYNTH_FOUND)
    make_plugin(fluidOpcodes fluidOpcodes.cpp)
    target_include_directories(fluidOpcodes PRIVATE ${FLUIDSYNTH_INCLUDE_DIR})
    target_include_directories(fluidOpcodes PRIVATE ${CSOUND_INCLUDE_DIR})
    target_link_libraries(fluidOpcodes ${FLUIDSYNTH_LIBRARIES})
endif()

=== hdf5/CMakeLists.txt ===
option(BUILD_HDF5_OPCODES "Build the hdf5 read/write opcodes" ON)

if(BUILD_HDF5_OPCODES)
    find_package(HDF5)

    if(HDF5_FOUND)
        # split version string, as cmake doesn't do this automatically
        string(REPLACE "." ";" VERSION_LIST ${HDF5_VERSION})
        list(GET VERSION_LIST 0 HDF5_VERSION_MAJOR)
        list(GET VERSION_LIST 1 HDF5_VERSION_MINOR)
        list(GET VERSION_LIST 2 HDF5_VERSION_PATCH)
        # add definitions so we can use them in the preprocessor
        ADD_DEFINITIONS(-DHDF5_VERSION_MAJOR=${HDF5_VERSION_MAJOR})
        ADD_DEFINITIONS(-DHDF5_VERSION_MINOR=${HDF5_VERSION_MINOR})
        ADD_DEFINITIONS(-DHDF5_VERSION_PATCH=${HDF5_VERSION_PATCH})
        if(MSVC)
            make_plugin(hdf5ops HDF5IO.c)
            target_include_directories(hdf5ops PRIVATE ${HDF5_INCLUDE_DIRS})
            target_link_libraries(hdf5ops PRIVATE hdf5::hdf5-static hdf5::hdf5_hl-static)
        else()
            message(STATUS "HDF5_INCLUDE_DIRS: ${HDF5_INCLUDE_DIRS}")
            message(STATUS "HDF5_LIBRARIES: ${HDF5_LIBRARIES}")
            make_plugin(hdf5ops HDF5IO.c)
            target_include_directories(hdf5ops PRIVATE ${HDF5_INCLUDE_DIRS})
            target_include_directories(hdf5ops PRIVATE ${CSOUND_INCLUDE_DIRS})
            target_link_libraries(hdf5ops ${HDF5_LIBRARIES})
        endif()
    endif()
endif()

=== image/CMakeLists.txt ===
# Build image opcodes
option(BUILD_IMAGE_OPCODES "Build the image opcodes" ON)

if(${BUILD_IMAGE_OPCODES})
    find_package(PNG)
    
    check_deps(BUILD_IMAGE_OPCODES PNG_FOUND)
    if(BUILD_IMAGE_OPCODES)
	make_plugin(image imageOpcodes.c)
	target_include_directories(image PRIVATE ${CSOUND_INCLUDE_DIRS})
	target_include_directories(image PRIVATE ${PNG_INCLUDE_DIR})
	target_link_libraries(image ${PNG_LIBRARIES})
	target_compile_definitions(image PRIVATE ${PNG_DEFINITIONS})
    endif()
endif()

=== jackops/CMakeLists.txt ===
option(BUILD_JACK_OPCODES "Build the JACK related opcodes" ON)
find_library(JACK_LIBRARY jack)
find_library(JACKDMP_LIBRARY jackdmp)
find_path (JACK_INCLUDE_DIR jack/jack.h HINTS /usr/local/include)
set(JACK_LIB ${JACK_LIBRARY})
if(NOT JACK_LIB)
  set(JACK_LIB ${JACKDMP_LIBRARY})
endif()

check_deps(BUILD_JACK_OPCODES JACK_LIB)
if(BUILD_JACK_OPCODES)
    set(jack_LIBS ${PTHREAD_LIBRARY})
    if(JACKDMP_LIBRARY)
        list(APPEND jack_LIBS ${JACKDMP_LIBRARY})
    else()
        list(APPEND jack_LIBS ${JACK_LIBRARY})
    endif()
    make_plugin(jacko jacko.cpp "${jack_LIBS}")
    target_include_directories(jacko PRIVATE ${CSOUND_INCLUDE_DIRS})
    target_include_directories(jacko PRIVATE ${JACK_INCLUDE_DIR})
    set_target_properties(jacko PROPERTIES COMPILE_FLAGS
   "-std=c++11")
    make_plugin(jackTransport jackTransport.c "${jack_LIBS}")
    target_include_directories(jackTransport PRIVATE ${CSOUND_INCLUDE_DIRS})
    target_include_directories(jackTransport PRIVATE ${JACK_INCLUDE_DIR})
endif()

=== linear_algebra/CMakeLists.txt ===
option(BUILD_LINEAR_ALGEBRA_OPCODES "Build the linear algebra opcodes" ON)

check_deps(BUILD_LINEAR_ALGEBRA_OPCODES USE_DOUBLE)
find_package(GMM)
if(BUILD_LINEAR_ALGEBRA_OPCODES AND GMM_FOUND)
    make_plugin(linear_algebra linear_algebra.cpp)
    target_include_directories(linear_algebra PRIVATE ${GMM_INCLUDE_DIR})
    target_include_directories(linear_algebra PRIVATE ${CSOUND_INCLUDE_DIR})
    target_compile_options(linear_algebra PRIVATE "-DGMM_VERSION")
    if (MSVC)
        target_compile_options(linear_algebra PRIVATE "/D_SCL_SECURE_NO_DEPRECATE")
    endif()
    message(STATUS "Building linear algebra opcodes")
endif()

=== mp3/CMakeLists.txt ===
option(BUILD_MP3OUT_OPCODE "Build the mp3out opcode" ON)
find_package(LAME)

check_deps(BUILD_MP3OUT_OPCODE LAME_FOUND)
if(BUILD_MP3OUT_OPCODE)
    make_plugin(mp3out mp3out.c ${LAME_LIBRARY})
    target_include_directories(mp3out PRIVATE ${LAME_INCLUDE_DIR})
    target_include_directories(mp3out PRIVATE ${CSOUND_INCLUDE_DIR})
endif()

=== opencl/CMakeLists.txt ===
option(BUILD_OPENCL_OPCODES "Build the OpenCL parallel opcodes" OFF)

if(BUILD_OPENCL_OPCODES)
find_library (OpenCL_library NAMES OpenCL)

if(BUILD_OPENCL_OPCODES)

function(make_opencl_plugin libname srcs)

    if(APPLE)
        add_library(${libname} SHARED ${srcs})
    else()
        add_library(${libname} MODULE ${srcs})
    endif()

    set(i 2)
    while( ${i} LESS ${ARGC} )
        target_link_libraries(${libname} ${ARGV${i}})
        math(EXPR i "${i}+1")
    endwhile()

    target_include_directories(${libname}  PRIVATE ${CSOUND_INCLUDE_DIRS})

#    set_target_properties(${libname} PROPERTIES
#        RUNTIME_OUTPUT_DIRECTORY ${BUILD_PLUGINS_DIR}
#        LIBRARY_OUTPUT_DIRECTORY ${BUILD_PLUGINS_DIR}
 #       ARCHIVE_OUTPUT_DIRECTORY ${BUILD_PLUGINS_DIR})

    install(TARGETS ${libname}
	LIBRARY DESTINATION "${PLUGIN_INSTALL_DIR}" )

endfunction(make_opencl_plugin)


 #include_directories(/usr/local/include)

 make_opencl_plugin(clop cladsynth.c)
 target_link_libraries(clop ${OpenCL_library})

 endif()

endif()

=== debian/changelog ===
csound-plugins (1.0.2~dfsg1-6) unstable; urgency=medium

  * Fix FTBFS with Cmake-4 (Closes: #1112818)
  * Modernize d/watch to version 5
  * Bump standards version to 4.7.2

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Tue, 30 Sep 2025 00:46:27 +0200

csound-plugins (1.0.2~dfsg1-5) unstable; urgency=medium

  * Fix FTBFS with gmm>=5.4.3 (Closes: #1095336)
  * Apply 'wrap-and-sort -ast'

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Sun, 09 Feb 2025 22:13:33 +0100

csound-plugins (1.0.2~dfsg1-4) unstable; urgency=medium

  * Compat with HDF5 1.14.
    (Closes: #1078984)
    Thanks to Pierre Gruet <pgt@debian.org> & Gilles Filippini <pini@debian.org>
  * Update copyright information
    + Bump copyright dates
    + Updated licensecheck target
    + Re-generate d/copyright_hints
  * Apply 'wrap-and-sort -ast'
  * Bump standards version to 4.7.0

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Wed, 18 Dec 2024 19:41:20 +0100

csound-plugins (1.0.2~dfsg1-3) unstable; urgency=medium

  * Recommend the 'stk' package
  * Set DEFAULT_STK_RAWWAVE_PATH when building
  * Apply 'wrap-and-sort -ast'

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Mon, 12 Dec 2022 08:17:29 +0100

csound-plugins (1.0.2~dfsg1-2) unstable; urgency=medium

  * Declare csound-plugins as Multi-Arch:same
  * Add first autopkgtest
  * Fix URI to salsa.d.o
  * Switch d/watch to use github tags rather than releases
  * Bump standards version to 4.6.1

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Wed, 28 Sep 2022 09:18:17 +0200

csound-plugins (1.0.2~dfsg1-1) unstable; urgency=medium

  * Upload to unstable.

  * Versioned B-D on libcsound64-dev
  * Add Breaks+Replaces: libcsound64-6.0 (Closes: #1006218)

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Mon, 21 Feb 2022 15:53:58 +0100

csound-plugins (1.0.2~dfsg1-1~exp1) experimental; urgency=medium

  * Initial release (Closes: #1005271)

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Thu, 10 Feb 2022 12:04:58 +0100

=== debian/control ===
Source: csound-plugins
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 ableton-link-dev,
 cmake,
 faust,
 fluid,
 libcsnd-dev (>= 1:6.17~),
 libcsound64-dev (>= 1:6.17~),
 libeigen3-dev,
 libfltk1.3-dev,
 libfluidsynth-dev,
 libgmm++-dev,
 libhdf5-dev,
 libjack-dev,
 libmp3lame-dev,
 libpng-dev,
 libstk-dev,
 libwebsockets-dev,
 python3-dev,
 zlib1g-dev | libz-dev,
Standards-Version: 4.7.2
Homepage: https://csound.com
Vcs-Browser: https://salsa.debian.org/multimedia-team/csound-plugins
Vcs-Git: https://salsa.debian.org/multimedia-team/csound-plugins.git
Rules-Requires-Root: no

Package: csound-plugins
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 stk,
Breaks:
 libcsound64-6.0 (<< 1:6.17),
Replaces:
 libcsound64-6.0 (<< 1:6.17),
Description: plugin collection for Csound
 Csound is a sound and music synthesis system. Drawing from over 450
 signal processing modules, it can be used to model virtually any
 synthesizer or multi-effect processor. It can work either in real-time
 or as a compiler.
 .
 Csound is to sound synthesis as C is to programming.
 .
 This package contains additional plugins (that depend on 3rd party libraries).

=== debian/rules ===
#!/usr/bin/make -f
# -*- mode: makefile; coding: utf-8 -*-
# Copyright © 2022 IOhannes m zmölnig <umlaeute@debian.org>
# Description: Main Debian packaging script for CSound Plugins

#export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export DEB_CPPFLAGS_MAINT_APPEND = -DH5_USE_110_API
%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_BUILD_RPATH_USE_ORIGIN=ON \
		-DBUILD_RELEASE=ON \
		-DUSE_GIT_COMMIT=OFF \
		-DUSE_DOUBLE=ON \
		-DABLETON_LINK_HOME=/ \
		-DDEFAULT_STK_RAWWAVE_PATH=/usr/share/stk/rawwaves \
		$(empty)

override_dh_auto_install:
	dh_auto_install --destdir=debian/tmp/


################ d/copyright helper ##############
DEB_COPYRIGHT_CHECK_IGNORE_REGEX = \
        debian/.*
# licensecheck v1
.PHONY: licensecheck
licensecheck:
	LANG=C.UTF-8 licensecheck \
		-i "^($(DEB_COPYRIGHT_CHECK_IGNORE_REGEX))$$" \
		--check '.*' --recursive --deb-machine --lines 0 * \
		> debian/copyright_newhints
	cmp debian/copyright_hints debian/copyright_newhints \
		&& rm debian/copyright_newhints

=== debian/tests/control ===
Test-Command: csound --nosound py/examples/embeddedCtcsound.csd
Depends:
 csound,
 csound-plugins,
 python3-csound,
Restrictions:
 allow-stderr,

=== debian/watch ===
Version: 5

# Run the "uscan" command to check for upstream updates and more.
Template: Github
Owner: csound
Project: plugins
Dversionmangle: auto
Repacksuffix: +dfsg
